/*
 *	app.h
 */
#ifndef __APP_H__
#define __APP_H__

#include "clip.h"
#include "usbcapt.h"	/* uPceCaps(v2001.12.18)Ήv */
#include "regsys.h"	/* uRegSysΉv */

/* * \_̃[Ɋւl@
 * - x1B3C1xAbvB
 * - Ԃ2J[[hB30x3J[[hB50x4J[[hB
 * - _VXe͂܂悭킩ȂB
 * - 1C1000_B
 *   2C()1000_A2000_B
 *   3C()1000_A2000_A4000_B
 *   4C()1000_A2000_A4000_A8000_B
 *   ...ƂȂĂ悤ȋC(Ԃ)B
 * - o[ɓđƂƁÅԓ_B
 * - ȂĂA]邾œ_B
 * - Xs[h̕ῶ܂悭킩ȂB
 *   J[[h̒ł񑬂ȂĂ܂xȂ肷B
 *   x̉1P^Xs[h낤?
 * - xɂȂƁAŃAj[VȂANEXT]TȂȂB
 */

/****************************************************************************
 *	`
 ****************************************************************************/

extern unsigned char _def_vbuff[DISP_X * DISP_Y]; /* zVRAM */
#define vbuff _def_vbuff

#define FPS	20			/* t[[g */
#define SEC(s)	((int)(FPS * (s)))	/* b->t[ϊ */

#define COLORMODE_TIME	SEC(1.5)	/* J[[h\ */
#define STAR_INTERVAL	SEC(0.75)	/* \Ԋu */
#define FLOAT_TIME	SEC(0.3)	/* V`Jn */
#define LAND_TIME	SEC(0.3)	/* n`ڒ */
#define MOVE_SPEED	3		/* ]x */
#define ROT_SPEED	3		/* ړx */

#define LEVEL_3COLORS	10		/* 3J[[hɂȂ郌x */
#define LEVEL_4COLORS	30		/* 4J[[hɂȂ郌x */

/* Xe[g */
enum {
	STATE_DEMO,		/* f */
	STATE_GAME,		/* Q[ */
	N_STATES,		/* Xe[g̐ */
};

/* Z */
typedef struct _CELL {
	char color;		/* F(0:/1:/2:/3:/4:) */
	char mode;		/* [h */
	short count;		/* Aj[VJE^ */
} CELL;
/* CELL.mode */
#define CM_NORMAL	0	/* ʏ */
#define CM_FLIP0	1	/* ɔ](colorƓl) */
#define CM_FLIP1	2	/* ɔ](colorƓl) */
#define CM_FLIP2	3	/* Âɔ](ÂcolorƓl) */
#define CM_FLIP3	4	/* ɔ](colorƓl) */
#define CM_ERASE	5	/*  */
#define CM_CLEAR	7	/* NA\_ʒuֈړ(ERASEƓtF[Y) */

/* ] */
typedef struct _FLIP {
	int x, y;	/* n_ */
	int vx, vy;	/*  */
	int n;		/* ](n_EI_܂܂) */
	int clear;	/* NA\_gp */
} FLIP;

/* tB[h */
#define FIELD_COLS	10
#define FIELD_ROWS	15
typedef struct _FIELD {
	int mode;		/* [h */
	int count;		/* ėpJE^ */
	int colors;		/* J[[h(2,3,4) */
	int speed;		/* x(8.8rbg) */
	int x, y;		/* Z̈ʒu(Ŏgp) */
	int rot;		/* ]p[^(Ŏgp) */
	int move_x;		/* ړp[^(Ŏgp) */
	int move_y;		/* p[^(Ŏgp) */
	int seed;		/* V[h */
	int score;		/* XRA */
	int line;		/* C */
	int level;		/* x */
	int n_erase;		/* C */
	int n_flip;		/* LȔ]̐ */
	FLIP flip[10];		/* ] */
	int star;		/* Aj[VJE^ */
	int block_offset;	/* ubNItZbg */
	char ctrl[2][2];	/* Z */
	char next[2][2];	/* NEXTZ */
	CELL cells[FIELD_ROWS][FIELD_COLS];	/* tB[hZ */
} FIELD;
/* FIELD.mode */
#define FM_TURN_INIT	 0	/* ^[Jn */
#define FM_COLORMODE	 1	/* J[[h\ */
#define FM_CTRL_INIT	10	/* () */
#define FM_CTRL_FLOAT	11	/* (V) */
#define FM_CTRL		12	/*  */
#define FM_CTRL_LAND	13	/* (n) */
#define FM_FLIP_INIT	20	/* ]() */
#define FM_FLIP		21	/* ] */
#define FM_ERASE_INIT	30	/* () */
#define FM_ERASE	31	/* Œ */
#define FM_FALL_INIT	40	/* () */
#define FM_FALL		41	/*  */
#define FM_OVER_INIT	50	/* Q[I[o[() */
#define FM_OVER		51	/* Q[I[o[ */

/* LN^ */
#define CHR(n, x, y, w, h) \
	CHR_##n##_X = (x), \
	CHR_##n##_Y = (y), \
	CHR_##n##_W = (w), \
	CHR_##n##_H = (h)
enum {
	/* wi */
	CHR(BACKGROUND,	 0, 40, 128, 88),
	/* \_ */
	CHR(SOLDAM0,	 0,  0,   7,  7),
	CHR(SOLDAM1,	 7,  0,   7,  7),
	CHR(SOLDAM2,	14,  0,   7,  7),
	CHR(SOLDAM3,	21,  0,   7,  7),
	/*  */
	CHR(STAR00,	 0,  7,   7,  7),
	CHR(STAR01,	 7,  7,   7,  7),
	CHR(STAR02,	14,  7,   7,  7),
	CHR(STAR10,	 0, 14,   7,  7),
	CHR(STAR11,	 7, 14,   7,  7),
	CHR(STAR12,	14, 14,   7,  7),
	/*  */
	CHR(ERASE0,	 0, 21,   7,  7),
	CHR(ERASE1,	 7, 21,   7,  7),
	CHR(ERASE2,	14, 21,   7,  7),
	CHR(ERASE3,	21, 21,   7,  7),
	/*  */
	CHR(LIGHT0,	21,  7,  13, 13),
	CHR(LIGHT1,	35,  7,  13, 13),
	CHR(LIGHT2,	49,  7,  13, 13),
	/* ubN */
	CHR(BLOCK0,	63,  7,  13, 13),
	CHR(BLOCK1,	77,  7,  13, 13),
	/* NEXT */
	CHR(NEXT,	91,  0,  26, 19),
	/* NA\_ */
	CHR(CLEARSOLDAM,28,  0,  61,  7),
};
#undef CHR
#define CHR(n) \
	CHR_##n##_X, \
	CHR_##n##_Y, \
	CHR_##n##_W, \
	CHR_##n##_H

/* \ʒu */
/* Z(EC܂܂) */
#define CELL_UNIT	6
/* ubN(EC܂܂) */
#define BLOCK_UNIT	12
/* tB[h */
#define FIELD_X		11
#define FIELD_Y		-3
#define FIELD_W		61
/* NA\_ */
#define CLEARSOLDAM_X	FIELD_X
#define CLEARSOLDAM_Y	81
/* ~bg */
#define LIMIT_X		(FIELD_X + 1)
#define LIMIT_Y		(FIELD_Y + 4)
#define LIMIT_W		(FIELD_W - 2)
#define LIMIT_H		2
/* NEXT */
#define NEXT_X		87
#define NEXT_Y		4
/* HI-SCORE */
#define HISCORE_X	83
#define HISCORE_Y	30
#define HISCORE_W	34
#define HISCORE_H	7
/* 1P-SCORE */
#define P1SCORE_X	HISCORE_X
#define P1SCORE_Y	39
#define P1SCORE_W	HISCORE_W
#define P1SCORE_H	HISCORE_H
/* LINE */
#define LINE_X		HISCORE_X
#define LINE_Y		48
#define LINE_W		HISCORE_W
#define LINE_H		HISCORE_H
/* x */
#define LEVEL_X		HISCORE_X
#define LEVEL_Y		61
#define LEVEL_W		34
#define LEVEL_H		23
/* J[[h */
#define COLORMODE_X	15
#define COLORMODE_Y	36
#define COLORMODE_W	53
#define COLORMODE_H	 7

/****************************************************************************
 *	ϐ
 ****************************************************************************/

extern char state[(N_STATES + 7) / 8];	/* Xe[g */
extern TASK* root_task;			/* [g^XN */
extern TASK* game_task;			/* Q[^XN */
extern int timer;			/* ^C} */
extern int pad;				/* pbh */
extern PIECE_BMP bmp[2];		/* rbg}bv(0:}XN/1:Ȃ) */
extern int hi_score;			/* nCXRA */
extern FIELD field;			/* tB[h */

/****************************************************************************
 *	֐
 ****************************************************************************/

/* data.c */
extern const unsigned char BITMAP[];

/* main.c */
void schedule();
int main();

/* demo.c */
void demo();

/* game.c */
void game();

/* field.c */
void field_draw(FIELD* field);
void field_init(FIELD* field);
int field_proc(FIELD* field);

#endif /*__APP_H__*/
